#ifndef DUCHAMP_OPTIMISED_GROWER_H_
#define DUCHAMP_OPTIMISED_GROWER_H_

#include <duchamp/param.hh>
#include <duchamp/Detection/ObjectGrower.hh>
#include <duchamp/Detection/detection.hh>

namespace duchamp{

    class OptimisedGrower : public ObjectGrower
    {
    public:
	OptimisedGrower();
	OptimisedGrower(Param &par);
	virtual ~OptimisedGrower(){};
  
	void grow(Detection *object);

	void setFlag(int x, int y, int z, STATE newstate);
	void setFlag(size_t pos, STATE newstate){itsFlagArray[pos] = newstate;};
	void setFlag(Voxel vox, STATE newstate){setFlag(vox.getX(),vox.getY(),vox.getZ(),newstate);};
	void setMaxIter(int i){maxIterations=i;};
	void setMaxMinZ(int max, int min){zmin=std::min(min,max);zmax=std::max(min,max);};
	void setClobber(bool b){clobberPrevious=b;};
	void findEllipse();
	Detection growMask();

    protected:
	double ell_a,ell_b,ell_theta;
	int maxIterations;
	float totalFlux, maxFlux;
	Detection *itsObj;
	int xObj, yObj, zmin, zmax;
	bool clobberPrevious;
    };


}

#endif
